// Generated by CoffeeScript 1.10.0
(function() {
  var CommonJsHandler, HandlerError, Promise, fs, path, util,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };

  fs = require('fs');

  path = require('path');

  Promise = require('bluebird');

  util = require('util');

  HandlerError = require('./error/HandlerError');

  module.exports = CommonJsHandler = (function() {
    function CommonJsHandler(template) {
      this.template = template;
      this.handleFile = bind(this.handleFile, this);
      if (this.template == null) {
        this.template = 'if (!module) { var module = {}; }\n\n%s\nmodule.exports;';
      }
    }

    CommonJsHandler.prototype.handleFile = function(filePath) {
      return new Promise((function(_this) {
        return function(resolve, reject) {
          if (path.extname(filePath) !== '.js') {
            return resolve(null);
          }
          return fs.readFile(filePath, function(error, data) {
            if (error) {
              error = new HandlerError('CommonJsHandler', filePath, error);
              return reject(error);
            }
            resolve([path.basename(filePath, '.js'), util.format(_this.template, data.toString())]);
          });
        };
      })(this));
    };

    return CommonJsHandler;

  })();

}).call(this);
